<?php 

add_filter('wpcf7_editor_panels', 'cf7du_form_settings');

function cf7du_form_settings($panels) {

	$panels['drop-uploader-panel'] = array(
			'title' => esc_html__( 'Drop Uploader', 'cf7-drop-uploader' ),
			'callback' => 'cf7du_editor_panel_drop_uploader',
		);

	return $panels;
}

function cf7du_editor_panel_drop_uploader( $post ) {

	$post_id = $post->id();

	$cf7du_folder = get_post_meta( $post_id, '_cf7du_folder', true );

	$cf7du_folder_enable = get_post_meta( $post_id, '_cf7du_folder_enable', true );

	?>
	<h2><?php echo esc_html__( 'Dropbox Settings', 'cf7-drop-uploader' ); ?></h2>
	<fieldset>
		<p>
			<label for="cf7du_folder_enable">
				<input type="checkbox" id="cf7du_folder_enable" name="cf7du_folder_enable" <?php if($cf7du_folder_enable == "on") {echo "checked";} ?> />
				<?php echo esc_html__( 'Put files, submitted with this form, to subfolder' ); ?>
			</label>
		</p>

		<p>
			<label for="cf7du_folder">
				<?php echo esc_html__( 'Subfolder name' ); ?>
				<input type="text" id="cf7du_folder" name="cf7du_folder" class="large-text" value="<?php echo $cf7du_folder ?>" />
			</label>
		</p>
	</fieldset>
	<script type="text/javascript">
		jQuery( document ).ready(function() {
			cf7du_subfolder_input_state();

			jQuery('#cf7du_folder_enable').on("change", function(){
				cf7du_subfolder_input_state();
			});
		});

		function cf7du_subfolder_input_state() {
			var cf7du_subfolder = jQuery('#cf7du_folder_enable').prop('checked');

			if(cf7du_subfolder) {
				jQuery('#cf7du_folder').prop('readonly', false);
			} else {
				jQuery('#cf7du_folder').prop('readonly', true);
			}
		}
	</script>
	<?php 
}

add_action('wpcf7_save_contact_form', 'cf7du_save_form_settings', 10, 3);

function cf7du_save_form_settings($contact_form, $args, $context) {

	$post_id = (int)$args['id'];

	$cf7du_folder = $args['cf7du_folder'];

	$cf7du_folder_enable = $args['cf7du_folder_enable'];

	if( metadata_exists( 'post', $post_id, '_cf7du_folder' ) ) {
		update_post_meta( $post_id, '_cf7du_folder', $cf7du_folder );
	} else {
		add_post_meta( $post_id, '_cf7du_folder', $cf7du_folder );
	}

	if( metadata_exists( 'post', $post_id, '_cf7du_folder_enable' ) ) {
		update_post_meta( $post_id, '_cf7du_folder_enable', $cf7du_folder_enable );
	} else {
		add_post_meta( $post_id, '_cf7du_folder_enable', $cf7du_folder_enable );
	}
}

