<?php 

/* AJAX Upload */

add_action('wp_ajax_cf7du_upload_file', 'cf7du_upload_file');
add_action('wp_ajax_nopriv_cf7du_upload_file', 'cf7du_upload_file');

function cf7du_upload_file() {
    global $wpdb;

    $rand_submission_id = $_REQUEST['submission_id'];

    $cf7du_files = get_option( 'cf7du_files' );

    $table_name = $wpdb->prefix . "cf7_drop_uploader";

    $wp_upload_dir = wp_upload_dir();

    $uploaddir = $wp_upload_dir['basedir'].DIRECTORY_SEPARATOR.CF7DU_TMP.DIRECTORY_SEPARATOR.$rand_submission_id.DIRECTORY_SEPARATOR;

    if(is_multisite()){ 
        $uploaddir = $wp_upload_dir['basedir'].DIRECTORY_SEPARATOR.'sites'.DIRECTORY_SEPARATOR.get_current_blog_id().DIRECTORY_SEPARATOR.CF7DU_TMP.DIRECTORY_SEPARATOR.$rand_submission_id.DIRECTORY_SEPARATOR;
    }

    if (!file_exists($uploaddir)) {
        mkdir($uploaddir, 0755, true);
    }

    // Check is delete action
    if(isset($_REQUEST['fileid'])) {
        $file_id = $_REQUEST['fileid'];

        $res = $wpdb->get_row("SELECT * FROM $table_name WHERE fileid = '$fileid'");

        $file_url = $res->filepath;

        if($file_url != "") {
            unlink($file_url);
        }
        wp_die();
    }

    if(isset($_POST['chunk']) && isset($_POST['chunk_last']) && isset($_POST['file_name']) && $_POST['file_name'] != '') {

        $filename = $_POST['file_name'];

        $chunk_number = $_POST['chunk'];

        $size = (int)$_POST['total_size'];
        
        $chunk_uploaded = true;

        $message = "";

        // Check Upload Errors

        if(isset($_FILES['file']['error']) && $_FILES['file']['error'] != UPLOAD_ERR_OK) {
            $chunk_uploaded = false;
            $message = "FILES Error code " . $_FILES['file']['error'];
        }

        $uploadfile = $uploaddir.$filename;

        $file_id = md5($uploadfile);

        $uploaded_file = fopen($_FILES['file']['tmp_name'], 'rb');

        $uploaded_data = fread($uploaded_file, filesize($_FILES['file']['tmp_name']));

        fclose($uploaded_file);

        $new_file = fopen($uploadfile, "ab");

        $bytes_fwrite = fwrite($new_file, $uploaded_data);

        fclose($new_file);

        // Upload chunk to Dropbox

        if(isset($cf7du_files['cf7du_dropbox_enable']) && $cf7du_files['cf7du_dropbox_enable'] == 'checked') {

            if(isset($_COOKIE['dbsid_' . $file_id])) {
                $cf7du_dropbox = new CF7DUDropbox($file_id, "", $_COOKIE['dbsid_' . $file_id]);
            } else {
                $cf7du_dropbox = new CF7DUDropbox($file_id);
            }

            $dbsid = $cf7du_dropbox->upload_file($_FILES['file']['tmp_name']);

            if($dbsid) {
                setcookie('dbsid_' . $file_id, $dbsid, time() + 36000);
            }
        } else {
            $dbsid = 0;
        }

        if($_FILES['file']['size'] != $bytes_fwrite) {
            $chunk_uploaded = false;

            $message = "Data partially written";
        }

        if($_POST['chunk_last'] == 'true' && $chunk_uploaded) {
            $response['success'] = true;
            $response['type'] = 'file';
            $response['file_id'] = $file_id;

            // Store File id in database. We can delete file by this id from other script
            $wpdb->insert( 
                $table_name, 
                array( 
                    'fileid' => $file_id, 
                    'filepath' => $uploadfile,
                    'filename' => $filename,
                    'dbsid' => $dbsid,
                    'dbfsize' => $size,
                    'created_at' => date("Y-m-d H:i:s")
                )
            );

            unset($_COOKIE['dbsid_' . $file_id]);
            setcookie('dbsid_' . $file_id, null, -1, '/');
        } else {
            $response['success'] = true;
            $response['type'] = 'chunk';
            $response['file_id'] = $file_id;
            if($message != "") {
                $response['message'] = $message;
            }
        }

        echo json_encode($response);

    }

    wp_die();

}
